<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:pkg="http://expath.org/ns/pkg"
                xmlns:web="http://expath.org/ns/webapp"
                xmlns:app="http://expath.org/ns/samples/servlex/hello"
                xmlns="http://www.w3.org/1999/xhtml"
                exclude-result-prefixes="#all"
                version="2.0">

   <pkg:import-uri>http://expath.org/ns/samples/servlex/hello.xsl</pkg:import-uri>

   <xsl:function name="app:hello-xslt">
      <xsl:param name="request" as="element(web:request)"/>
      <xsl:param name="bodies"  as="item()*"/>
      <xsl:variable name="who" select="$request/web:param[@name eq 'who']/@value"/>
      <xsl:variable name="greetings" select="concat('Hello, ', $who, '!')"/>
      <web:response status="200" message="Ok">
         <web:body content-type="application/xml" method="xhtml"/>
      </web:response>
      <html>
         <head>
            <title>
               <xsl:value-of select="$greetings"/>
            </title>
         </head>
         <body>
            <p>
               <xsl:value-of select="$greetings"/>
               <xsl:text> (in XSLT)</xsl:text>
            </p>
         </body>
      </html>
   </xsl:function>

   <xsl:function name="app:home-servlet">
      <xsl:param name="request" as="element(web:request)"/>
      <xsl:param name="bodies"  as="item()*"/>
      <web:response status="200" message="Ok">
         <web:body content-type="application/xml" method="xhtml"/>
      </web:response>
      <html>
         <head>
            <title>Hello, world!</title>
         </head>
         <body>
            <h2>Hello, world!</h2>
            <p>Welcome!  Type down your name to see the result
              using different technologies.</p>
            <p>
               <form action="xslt" method="get">
                  <span>Name:</span>
                  <input type="text" name="who"/>
                  <input type="submit" value="XSLT"/>
               </form>
            </p>
            <p>
               <form action="xquery" method="get">
                  <span>Name:</span>
                  <input type="text" name="who"/>
                  <input type="submit" value="XQuery"/>
               </form>
            </p>
            <p>
               <form action="xproc" method="get">
                  <span>Name:</span>
                  <input type="text" name="who"/>
                  <input type="submit" value="XProc"/>
               </form>
            </p>
            <p>
               <xsl:text>Or maybe you want to see the XML representation</xsl:text>
               <xsl:text>of the HTTP request?  Go to </xsl:text>
               <a href="http://h2oconsulting.be/tools/dump">this tool</a>
               <xsl:text>, or access it via the following form.</xsl:text>
               <form action="http://h2oconsulting.be/tools/dump" method="get">
                  <span>Name:</span>
                  <input type="text" name="who"/>
                  <input type="submit" value="Dump"/>
               </form>
            </p>
         </body>
      </html>
   </xsl:function>

</xsl:stylesheet>
